Index: /palm/trunk/SOURCE/lpm_init.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_init.f90	(revision 2311)
+++ /palm/trunk/SOURCE/lpm_init.f90	(revision 2312)
@@ -20,43 +20,46 @@
 ! Current revisions:
 ! -----------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Extended particle data type. Aerosol initialization improved.
+!
+! 2305 2017-07-06 11:18:47Z hoffmann
 ! Improved calculation of particle IDs.
-! 
+!
 ! 2274 2017-06-09 13:27:48Z Giersch
 !  Changed error messages
-! 
+!
 ! 2265 2017-06-08 16:58:28Z schwenkel
 ! Unused variables removed.
-! 
+!
 ! 2263 2017-06-08 14:59:01Z schwenkel
 ! Implemented splitting and merging algorithm
-! 
+!
 ! 2233 2017-05-30 18:08:54Z suehring
 !
 ! 2232 2017-05-30 17:47:52Z suehring
 ! Adjustments according to new topography realization
-! 
-! 
+!
+!
 ! 2223 2017-05-15 16:38:09Z suehring
 ! Add check for particle release at model top
-! 
+!
 ! 2182 2017-03-17 14:27:40Z schwenkel
 ! Added parameters for simplified particle initialization.
 !
 ! 2122 2017-01-18 12:22:54Z hoffmann
-! Improved initialization of equilibrium aerosol radii 
+! Improved initialization of equilibrium aerosol radii
 ! Calculation of particle ID
 !
 ! 2000 2016-08-20 18:09:15Z knoop
 ! Forced header and separation lines into 80 columns
-! 
+!
 ! 2016-06-09 16:25:25Z suehring
-! Bugfix in determining initial particle height and grid index in case of 
+! Bugfix in determining initial particle height and grid index in case of
 ! seed_follows_topography.
-! Bugfix concerning random positions, ensure that particles do not move more 
+! Bugfix concerning random positions, ensure that particles do not move more
 ! than one grid length.
 ! Bugfix logarithmic interpolation.
@@ -64,5 +67,5 @@
 !
 ! 1890 2016-04-22 08:52:11Z hoffmann
-! Initialization of aerosol equilibrium radius not possible in supersaturated 
+! Initialization of aerosol equilibrium radius not possible in supersaturated
 ! environments. Therefore, a maximum supersaturation of -1 % is assumed during
 ! initialization.
@@ -70,5 +73,5 @@
 ! 1873 2016-04-18 14:50:06Z maronga
 ! Module renamed (removed _mod
-! 
+!
 ! 1871 2016-04-15 11:46:09Z hoffmann
 ! Initialization of aerosols added.
@@ -86,6 +89,6 @@
 ! netcdf module added
 !
-! 1725 2015-11-17 13:01:51Z hoffmann 
-! Bugfix: Processor-dependent seed for random function is generated before it is 
+! 1725 2015-11-17 13:01:51Z hoffmann
+! Bugfix: Processor-dependent seed for random function is generated before it is
 ! used.
 !
@@ -97,5 +100,5 @@
 !
 ! 1682 2015-10-07 23:56:08Z knoop
-! Code annotations made doxygen readable 
+! Code annotations made doxygen readable
 !
 ! 1575 2015-03-27 09:56:27Z raasch
@@ -103,8 +106,8 @@
 !
 ! 1359 2014-04-11 17:15:14Z hoffmann
-! New particle structure integrated. 
+! New particle structure integrated.
 ! Kind definition added to all floating point numbers.
 ! lpm_init changed form a subroutine to a module.
-! 
+!
 ! 1327 2014-03-21 11:00:16Z raasch
 ! -netcdf_output
@@ -123,5 +126,5 @@
 !
 ! 1314 2014-03-14 18:25:17Z suehring
-! Vertical logarithmic interpolation of horizontal particle speed for particles 
+! Vertical logarithmic interpolation of horizontal particle speed for particles
 ! between roughness height and first vertical grid level.
 !
@@ -146,5 +149,5 @@
 !
 ! 667 2010-12-23 12:06:00Z suehring/gryschka
-! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng for allocation 
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng for allocation
 ! of arrays.
 !
@@ -159,5 +162,5 @@
 !------------------------------------------------------------------------------!
  MODULE lpm_init_mod
- 
+
     USE, INTRINSIC ::  ISO_C_BINDING
 
@@ -167,5 +170,6 @@
     USE control_parameters,                                                    &
         ONLY:  cloud_droplets, constant_flux_layer, current_timestep_number,   &
-               dz, initializing_actions, message_string, ocean, simulated_time
+               dt_3d, dz, initializing_actions, message_string, ocean,         &
+               simulated_time
 
     USE grid_variables,                                                        &
@@ -197,6 +201,6 @@
                 particles, particle_advection_start, particle_groups,          &
                 particle_groups_type, particles_per_point,                     &
-                particle_type, pdx, pdy, pdz,  prt_count, psb, psl, psn, psr,  & 
-                pss, pst, radius, random_start_position,                       &  
+                particle_type, pdx, pdy, pdz,  prt_count, psb, psl, psn, psr,  &
+                pss, pst, radius, random_start_position,                       &
                 read_particles_from_restartfile, seed_follows_topography,      &
                 sgs_wf_part, sort_count, splitting_function, splitting_mode,   &
@@ -247,5 +251,5 @@
     INTEGER(iwp) ::  k                           !<
 
-    REAL(wp) ::  div                             !< 
+    REAL(wp) ::  div                             !<
     REAL(wp) ::  height_int                      !<
     REAL(wp) ::  height_p                        !<
@@ -286,11 +290,11 @@
 !-- Check if downward-facing walls exist. This case, reflection boundary
 !-- conditions (as well as subgrid-scale velocities) may do not work
-!-- propably (not realized so far). 
+!-- propably (not realized so far).
     IF ( surf_def_h(1)%ns >= 1 )  THEN
-       WRITE( message_string, * ) 'Overhanging topography do not work '// &   
-                                  'with particles' 
+       WRITE( message_string, * ) 'Overhanging topography do not work '// &
+                                  'with particles'
        CALL message( 'lpm_init', 'PA0212', 0, 1, 0, 6, 0 )
 
-    ENDIF 
+    ENDIF
 
 !
@@ -310,10 +314,10 @@
 !-- If number_particles_per_gridbox is set, the parametres pdx, pdy and pdz are
 !-- calculated diagnostically. Therfore an isotropic distribution is prescribed.
-    IF ( number_particles_per_gridbox /= -1 .AND.   & 
+    IF ( number_particles_per_gridbox /= -1 .AND.   &
          number_particles_per_gridbox >= 1 )    THEN
-       pdx(1) = (( dx * dy * ( zu(2) - zu(1) ) ) /  & 
+       pdx(1) = (( dx * dy * ( zu(2) - zu(1) ) ) /  &
              REAL(number_particles_per_gridbox))**0.3333333_wp
 !
-!--    Ensure a smooth value (two significant digits) of distance between 
+!--    Ensure a smooth value (two significant digits) of distance between
 !--    particles (pdx, pdy, pdz).
        div = 1000.0_wp
@@ -340,5 +344,5 @@
 
 !
-!-- Allocate arrays required for calculating particle SGS velocities. 
+!-- Allocate arrays required for calculating particle SGS velocities.
 !-- Initialize prefactor required for stoachastic Weil equation.
     IF ( use_sgs_for_particles  .AND.  .NOT. cloud_droplets )  THEN
@@ -347,25 +351,25 @@
                  de_dz(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 
-       sgs_wf_part = 1.0_wp / 3.0_wp    
+       sgs_wf_part = 1.0_wp / 3.0_wp
     ENDIF
 
 !
-!-- Allocate array required for logarithmic vertical interpolation of 
+!-- Allocate array required for logarithmic vertical interpolation of
 !-- horizontal particle velocities between the surface and the first vertical
-!-- grid level. In order to avoid repeated CPU cost-intensive CALLS of 
-!-- intrinsic FORTRAN procedure LOG(z/z0), LOG(z/z0) is precalculated for 
-!-- several heights. Splitting into 20 sublayers turned out to be sufficient. 
+!-- grid level. In order to avoid repeated CPU cost-intensive CALLS of
+!-- intrinsic FORTRAN procedure LOG(z/z0), LOG(z/z0) is precalculated for
+!-- several heights. Splitting into 20 sublayers turned out to be sufficient.
 !-- To obtain exact height levels of particles, linear interpolation is applied
 !-- (see lpm_advec.f90).
     IF ( constant_flux_layer )  THEN
-       
-       ALLOCATE ( log_z_z0(0:number_of_sublayers) ) 
+
+       ALLOCATE ( log_z_z0(0:number_of_sublayers) )
        z_p = zu(nzb+1) - zw(nzb)
 
 !
 !--    Calculate horizontal mean value of z0 used for logartihmic
-!--    interpolation. Note: this is not exact for heterogeneous z0. 
-!--    However, sensitivity studies showed that the effect is 
-!--    negligible. 
+!--    interpolation. Note: this is not exact for heterogeneous z0.
+!--    However, sensitivity studies showed that the effect is
+!--    negligible.
        z0_av_local  = SUM( surf_def_h(0)%z0 ) + SUM( surf_lsm_h%z0 ) +         &
                       SUM( surf_usm_h%z0 )
@@ -401,5 +405,5 @@
 !-- Check boundary condition and set internal variables
     SELECT CASE ( bc_par_b )
-    
+
        CASE ( 'absorb' )
           ibc_par_b = 1
@@ -407,13 +411,13 @@
        CASE ( 'reflect' )
           ibc_par_b = 2
-          
+
        CASE DEFAULT
           WRITE( message_string, * )  'unknown boundary condition ',   &
                                        'bc_par_b = "', TRIM( bc_par_b ), '"'
           CALL message( 'lpm_init', 'PA0217', 1, 2, 0, 6, 0 )
-          
+
     END SELECT
     SELECT CASE ( bc_par_t )
-    
+
        CASE ( 'absorb' )
           ibc_par_t = 1
@@ -421,10 +425,10 @@
        CASE ( 'reflect' )
           ibc_par_t = 2
-          
+
        CASE DEFAULT
           WRITE( message_string, * ) 'unknown boundary condition ',   &
                                      'bc_par_t = "', TRIM( bc_par_t ), '"'
           CALL message( 'lpm_init', 'PA0218', 1, 2, 0, 6, 0 )
-          
+
     END SELECT
     SELECT CASE ( bc_par_lr )
@@ -438,10 +442,10 @@
        CASE ( 'reflect' )
           ibc_par_lr = 2
-          
+
        CASE DEFAULT
           WRITE( message_string, * ) 'unknown boundary condition ',   &
                                      'bc_par_lr = "', TRIM( bc_par_lr ), '"'
           CALL message( 'lpm_init', 'PA0219', 1, 2, 0, 6, 0 )
-          
+
     END SELECT
     SELECT CASE ( bc_par_ns )
@@ -455,13 +459,13 @@
        CASE ( 'reflect' )
           ibc_par_ns = 2
-          
+
        CASE DEFAULT
           WRITE( message_string, * ) 'unknown boundary condition ',   &
                                      'bc_par_ns = "', TRIM( bc_par_ns ), '"'
           CALL message( 'lpm_init', 'PA0220', 1, 2, 0, 6, 0 )
-          
+
     END SELECT
     SELECT CASE ( splitting_mode )
-    
+
        CASE ( 'const' )
           i_splitting_mode = 1
@@ -472,13 +476,13 @@
        CASE ( 'gb_av' )
           i_splitting_mode = 3
-          
+
        CASE DEFAULT
           WRITE( message_string, * )  'unknown splitting condition ',   &
                                        'splitting_mode = "', TRIM( splitting_mode ), '"'
           CALL message( 'lpm_init', 'PA0146', 1, 2, 0, 6, 0 )
-          
+
     END SELECT
     SELECT CASE ( splitting_function )
-    
+
        CASE ( 'gamma' )
           isf = 1
@@ -489,12 +493,12 @@
        CASE ( 'exp' )
           isf = 3
-          
+
        CASE DEFAULT
           WRITE( message_string, * )  'unknown splitting function ',   &
                                        'splitting_function = "', TRIM( splitting_function ), '"'
           CALL message( 'lpm_init', 'PA0147', 1, 2, 0, 6, 0 )
-          
+
     END SELECT
-    
+
 
 !
@@ -524,5 +528,5 @@
 
 !
-!--    initialize counter for particle IDs 
+!--    initialize counter for particle IDs
        grid_particles%id_counter = 1
 
@@ -534,5 +538,5 @@
                                       0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp,  &
                                       0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp,  &
-                                      0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp,          &
+                                      0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp,  &
                                       0, 0, 0_idp, .FALSE., -1 )
 
@@ -577,5 +581,5 @@
           CALL check_open( 80 )
           WRITE ( 80, 8000 )  current_timestep_number, simulated_time,         &
-                              number_of_particles                             
+                              number_of_particles
           CALL close_file( 80 )
        ENDIF
@@ -584,5 +588,5 @@
 
 !
-!-- To avoid programm abort, assign particles array to the local version of 
+!-- To avoid programm abort, assign particles array to the local version of
 !-- first grid cell
     number_of_particles = prt_count(nzb+1,nys,nxl)
@@ -608,5 +612,5 @@
 
     USE particle_attributes,                                                   &
-        ONLY: deleted_particles, monodisperse_aerosols
+        ONLY: deleted_particles
 
     IMPLICIT  NONE
@@ -631,7 +635,7 @@
     LOGICAL                    ::  first_stride !< flag for initialization
 
-    REAL(wp)                   ::  pos_x      !< increment for particle position in x      
-    REAL(wp)                   ::  pos_y      !< increment for particle position in y  
-    REAL(wp)                   ::  pos_z      !< increment for particle position in z     
+    REAL(wp)                   ::  pos_x      !< increment for particle position in x
+    REAL(wp)                   ::  pos_y      !< increment for particle position in y
+    REAL(wp)                   ::  pos_z      !< increment for particle position in z
     REAL(wp)                   ::  rand_contr !< dummy argument for random position
 
@@ -652,6 +656,6 @@
 !--    Calculate initial_weighting_factor diagnostically
        IF ( number_concentration /= -1.0_wp .AND. number_concentration > 0.0_wp ) THEN
-          initial_weighting_factor =  number_concentration * 1.0E6_wp *             & 
-                                      pdx(1) * pdy(1) * pdz(1) 
+          initial_weighting_factor =  number_concentration * 1.0E6_wp *             &
+                                      pdx(1) * pdy(1) * pdz(1)
        END IF
 
@@ -677,5 +681,5 @@
                xloop: DO WHILE ( pos_x <= psr(i) )
 
-                         IF ( pos_x >= ( nxl - 0.5_wp ) * dx  .AND.            & 
+                         IF ( pos_x >= ( nxl - 0.5_wp ) * dx  .AND.            &
                               pos_x <  ( nxr + 0.5_wp ) * dx )  THEN
 
@@ -690,20 +694,8 @@
                                tmp_particle%age_m         = 0.0_wp
                                tmp_particle%dt_sum        = 0.0_wp
-                               tmp_particle%user          = 0.0_wp !unused, free for the user
                                tmp_particle%e_m           = 0.0_wp
-                               IF ( curvature_solution_effects )  THEN
-!
-!--                               Initial values (internal timesteps, derivative)
-!--                               for Rosenbrock method
-                                  tmp_particle%rvar1      = 1.0E-6_wp     !last Rosenbrock timestep
-                                  tmp_particle%rvar2      = 0.1E-6_wp     !dry aerosol radius
-                                  tmp_particle%rvar3      = -9999999.9_wp !unused in this configuration
-                               ELSE
-!
-!--                               Initial values for SGS velocities
-                                  tmp_particle%rvar1      = 0.0_wp
-                                  tmp_particle%rvar2      = 0.0_wp
-                                  tmp_particle%rvar3      = 0.0_wp
-                               ENDIF
+                               tmp_particle%rvar1         = 0.0_wp
+                               tmp_particle%rvar2         = 0.0_wp
+                               tmp_particle%rvar3         = 0.0_wp
                                tmp_particle%speed_x       = 0.0_wp
                                tmp_particle%speed_y       = 0.0_wp
@@ -712,4 +704,11 @@
                                tmp_particle%origin_y      = pos_y
                                tmp_particle%origin_z      = pos_z
+                               IF ( curvature_solution_effects )  THEN
+                                  tmp_particle%aux1      = 0.0_wp    ! dry aerosol radius
+                                  tmp_particle%aux2      = dt_3d     ! last Rosenbrock timestep
+                               ELSE
+                                  tmp_particle%aux1      = 0.0_wp    ! free to use
+                                  tmp_particle%aux2      = 0.0_wp    ! free to use
+                               ENDIF
                                tmp_particle%radius        = particle_groups(i)%radius
                                tmp_particle%weight_factor = initial_weighting_factor
@@ -726,5 +725,5 @@
 !
 !--                            Determine surface level. Therefore, check for
-!--                            upward-facing wall on w-grid. MAXLOC will return 
+!--                            upward-facing wall on w-grid. MAXLOC will return
 !--                            the index of the lowest upward-facing wall.
                                k_surf = MAXLOC(                                &
@@ -748,5 +747,5 @@
                                   ENDIF
 !
-!--                            Skip particle release if particle position is 
+!--                            Skip particle release if particle position is
 !--                            below surface, or within topography in case
 !--                            of overhanging structures.
@@ -756,5 +755,5 @@
                                THEN
                                   pos_x = pos_x + pdx(i)
-                                  CYCLE xloop                               
+                                  CYCLE xloop
                                ENDIF
 
@@ -840,5 +839,5 @@
              particles => grid_particles(kp,jp,ip)%particles(1:number_of_particles)
 
-             DO  n = local_start(kp,jp,ip), number_of_particles  !only new particles 
+             DO  n = local_start(kp,jp,ip), number_of_particles  !only new particles
 
                 particles(n)%id = 10000_idp**3 * grid_particles(kp,jp,ip)%id_counter + &
@@ -857,5 +856,5 @@
 !
 !-- Initialize aerosol background spectrum
-    IF ( curvature_solution_effects  .AND.  .NOT. monodisperse_aerosols )  THEN
+    IF ( curvature_solution_effects )  THEN
        CALL lpm_init_aerosols(local_start)
     ENDIF
@@ -871,9 +870,9 @@
                 particles => grid_particles(kp,jp,ip)%particles(1:number_of_particles)
 !
-!--             Move only new particles. Moreover, limit random fluctuation 
-!--             in order to prevent that particles move more than one grid box, 
-!--             which would lead to problems concerning particle exchange 
-!--             between processors in case pdx/pdy are larger than dx/dy, 
-!--             respectively.  
+!--             Move only new particles. Moreover, limit random fluctuation
+!--             in order to prevent that particles move more than one grid box,
+!--             which would lead to problems concerning particle exchange
+!--             between processors in case pdx/pdy are larger than dx/dy,
+!--             respectively.
                 DO  n = local_start(kp,jp,ip), number_of_particles
                    IF ( psl(particles(n)%group) /= psr(particles(n)%group) )  THEN
@@ -883,5 +882,5 @@
                               MERGE( rand_contr, SIGN( dx, rand_contr ),       &
                                      ABS( rand_contr ) < dx                    &
-                                   ) 
+                                   )
                    ENDIF
                    IF ( pss(particles(n)%group) /= psn(particles(n)%group) )  THEN
@@ -891,5 +890,5 @@
                               MERGE( rand_contr, SIGN( dy, rand_contr ),       &
                                      ABS( rand_contr ) < dy                    &
-                                   ) 
+                                   )
                    ENDIF
                    IF ( psb(particles(n)%group) /= pst(particles(n)%group) )  THEN
@@ -899,5 +898,5 @@
                               MERGE( rand_contr, SIGN( dz, rand_contr ),       &
                                      ABS( rand_contr ) < dz                    &
-                                   ) 
+                                   )
                    ENDIF
                 ENDDO
@@ -908,5 +907,5 @@
 !
 !--             Furthermore, remove particles located in topography. Note, as
-!--             the particle speed is still zero at this point, wall 
+!--             the particle speed is still zero at this point, wall
 !--             reflection boundary conditions will not work in this case.
                 particles =>                                                   &
@@ -934,7 +933,7 @@
     ENDIF
 !
-!-- In case of random_start_position, delete particles identified by 
-!-- lpm_exchange_horiz and lpm_boundary_conds. Then sort particles into blocks, 
-!-- which is needed for a fast interpolation of the LES fields on the particle 
+!-- In case of random_start_position, delete particles identified by
+!-- lpm_exchange_horiz and lpm_boundary_conds. Then sort particles into blocks,
+!-- which is needed for a fast interpolation of the LES fields on the particle
 !-- position.
     CALL lpm_pack_all_arrays
@@ -967,5 +966,5 @@
 
     USE arrays_3d,                                                             &
-        ONLY: hyp, pt, q  
+        ONLY: hyp, pt, q
 
     USE cloud_parameters,                                                      &
@@ -978,69 +977,66 @@
 
     USE particle_attributes,                                                   &
-        ONLY: init_aerosol_probabilistic, molecular_weight_of_solute,          &
-              molecular_weight_of_water, n1, n2, n3, rho_s, rm1, rm2, rm3,     &
-              s1, s2, s3, vanthoff
+        ONLY: aero_type, aero_weight, log_sigma, molecular_weight_of_solute,   &
+              molecular_weight_of_water, na, rho_s, rm, vanthoff
 
     IMPLICIT NONE
-
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  cdf     !< CDF of aerosol spectrum 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  r_temp  !< dry aerosol radius spectrum
 
     REAL(wp)  :: afactor            !< curvature effects
     REAL(wp)  :: bfactor            !< solute effects
-    REAL(wp)  :: dr                 !< width of radius bin
+    REAL(wp)  :: dlogr              !< logarithmic width of radius bin
     REAL(wp)  :: e_a                !< vapor pressure
     REAL(wp)  :: e_s                !< saturation vapor pressure
-    REAL(wp)  :: n_init             !< sum of all aerosol concentrations
-    REAL(wp)  :: pdf                !< PDF of aerosol spectrum
-    REAL(wp)  :: rmin = 1.0e-8_wp   !< minimum aerosol radius
-    REAL(wp)  :: rmax = 1.0e-6_wp   !< maximum aerosol radius
-    REAL(wp)  :: rs_rand            !< random number
-    REAL(wp)  :: r_mid              !< mean radius
+    REAL(wp)  :: rmin = 0.005e-6_wp !< minimum aerosol radius
+    REAL(wp)  :: rmax = 10.0e-6_wp  !< maximum aerosol radius
+    REAL(wp)  :: r_mid              !< mean radius of bin
+    REAL(wp)  :: r_l                !< left radius of bin
+    REAL(wp)  :: r_r                !< right radius of bin
     REAL(wp)  :: sigma              !< surface tension
     REAL(wp)  :: t_int              !< temperature
-    REAL(wp)  :: weight_sum         !< sum of all weighting factors
 
     INTEGER(iwp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(IN) ::  local_start !<
 
     INTEGER(iwp)  :: n              !<
-    INTEGER(iwp)  :: nn             !<
-    INTEGER(iwp)  :: no_bins = 999  !< number of bins
     INTEGER(iwp)  :: ip             !<
     INTEGER(iwp)  :: jp             !<
     INTEGER(iwp)  :: kp             !<
 
-    LOGICAL ::  new_pdf = .FALSE.   !< check if aerosol PDF has to be recalculated
-
-!
-!-- Compute aerosol background distribution
-    IF ( init_aerosol_probabilistic )  THEN
-       ALLOCATE( cdf(0:no_bins), r_temp(0:no_bins) )
-       DO n = 0, no_bins
-          r_temp(n) = EXP( LOG(rmin) + ( LOG(rmax) - LOG(rmin ) ) /            &
-                           REAL(no_bins, KIND=wp) * REAL(n, KIND=wp) )
-
-          cdf(n) = 0.0_wp
-          n_init = n1 + n2 + n3
-          IF ( n1 > 0.0_wp )  THEN 
-             cdf(n) = cdf(n) + n1 / n_init * ( 0.5_wp + 0.5_wp *        &
-                                  ERF( LOG( r_temp(n) / rm1 ) /         &
-                                       ( SQRT(2.0_wp) * LOG(s1) )       &
-                                     ) )
-          ENDIF
-          IF ( n2 > 0.0_wp )  THEN 
-             cdf(n) = cdf(n) + n2 / n_init * ( 0.5_wp + 0.5_wp *        &
-                                  ERF( LOG( r_temp(n) / rm2 ) /         &
-                                       ( SQRT(2.0_wp) * LOG(s2) )       &
-                                     ) )
-          ENDIF
-          IF ( n3 > 0.0_wp )  THEN 
-             cdf(n) = cdf(n) + n3 / n_init * ( 0.5_wp + 0.5_wp *        &
-                                  ERF( LOG( r_temp(n) / rm3 ) /         &
-                                       ( SQRT(2.0_wp) * LOG(s3) )       &
-                                     ) )
-          ENDIF
-
-       ENDDO
+!
+!-- The following typical aerosol spectra are taken from Jaenicke (1993):
+!-- Tropospheric aerosols. Published in Aerosol-Cloud-Climate Interactions.
+    IF ( TRIM(aero_type) .EQ. 'polar' )  THEN
+       na        = (/ 2.17e1, 1.86e-1, 3.04e-4 /) * 1.0E6
+       rm        = (/ 0.0689, 0.375, 4.29 /) * 1.0E-6
+       log_sigma = (/ 0.245, 0.300, 0.291 /)
+    ELSEIF ( TRIM(aero_type) .EQ. 'background' )  THEN
+       na        = (/ 1.29e2, 5.97e1, 6.35e1 /) * 1.0E6
+       rm        = (/ 0.0036, 0.127, 0.259 /) * 1.0E-6
+       log_sigma = (/ 0.645, 0.253, 0.425 /)
+    ELSEIF ( TRIM(aero_type) .EQ. 'maritime' )  THEN
+       na        = (/ 1.33e2, 6.66e1, 3.06e0 /) * 1.0E6
+       rm        = (/ 0.0039, 0.133, 0.29 /) * 1.0E-6
+       log_sigma = (/ 0.657, 0.210, 0.396 /)
+    ELSEIF ( TRIM(aero_type) .EQ. 'continental' )  THEN
+       na        = (/ 3.20e3, 2.90e3, 3.00e-1 /) * 1.0E6
+       rm        = (/ 0.01, 0.058, 0.9 /) * 1.0E-6
+       log_sigma = (/ 0.161, 0.217, 0.380 /)
+    ELSEIF ( TRIM(aero_type) .EQ. 'desert' )  THEN
+       na        = (/ 7.26e2, 1.14e3, 1.78e-1 /) * 1.0E6
+       rm        = (/ 0.001, 0.0188, 10.8 /) * 1.0E-6
+       log_sigma = (/ 0.247, 0.770, 0.438 /)
+    ELSEIF ( TRIM(aero_type) .EQ. 'rural' )  THEN
+       na        = (/ 6.65e3, 1.47e2, 1.99e3 /) * 1.0E6
+       rm        = (/ 0.00739, 0.0269, 0.0419 /) * 1.0E-6
+       log_sigma = (/ 0.225, 0.557, 0.266 /)
+    ELSEIF ( TRIM(aero_type) .EQ. 'urban' )  THEN
+       na        = (/ 9.93e4, 1.11e3, 3.64e4 /) * 1.0E6
+       rm        = (/ 0.00651, 0.00714, 0.0248 /) * 1.0E-6
+       log_sigma = (/ 0.245, 0.666, 0.337 /)
+    ELSEIF ( TRIM(aero_type) .EQ. 'user' )  THEN
+       CONTINUE
+    ELSE
+       WRITE( message_string, * ) 'unknown aerosol type ',   &
+                                'aero_type = "', TRIM( aero_type ), '"'
+       CALL message( 'lpm_init', 'PA0459', 1, 2, 0, 6, 0 )
     ENDIF
 
